library app_auto_localize;

import 'dart:io';

import 'package:translator/translator.dart';


String projectApsolutePath ="";
String defaultLocal ='';
_write(Map jsonData,String local) async {
  String dataToWrite = '{\n';
  final File file = File('$projectApsolutePath/assets/app_auto_localize/$local.json');
  await file.create();
  for (String key in jsonData.keys){
    dataToWrite=dataToWrite+key+':'+jsonData[key]+','+'\n';
  }
  dataToWrite=dataToWrite.substring(0,dataToWrite.length-2);
  dataToWrite=dataToWrite+'\n}';
  file.writeAsString(dataToWrite);
}


List<String?> jsonData = [];
readContentItem(i,String local) async {
  try{
    final file =File(_folders[i].path);
    // Read the file
    final newFileContent = await file.readAsString();
    List<String?> newArray = extractHashtags(newFileContent);
    jsonData =  jsonData+newArray;
    if(i==_folders.length-1){
      print(jsonData);
      transl(jsonData,local);
    }
  }catch(e){
  }
}
Future<String> transl(List list,String local) async {
  final textToTranslate = jsonData.join('大');
  final translator = GoogleTranslator();
  var result =  await translator.translate(textToTranslate, from: defaultLocal, to: local);

  List translatedResult = result.text.split('大');
  Map jsonResult = {};
  for(int i=0;i<list.length;i++){
    jsonResult[list[i]] = (translatedResult[i]==''||translatedResult[i]==null)?'-':translatedResult[i];
  }
  _write(jsonResult,local);

  return result.text;
}

readContent(String local) async {
  getDir();
  for(int i=0;i<_folders.length;i++){
    readContentItem(i,local);
  }
}

List<FileSystemEntity> _folders=[];
getDir()  {
  final dir = '$projectApsolutePath/lib';
  String pdfDirectory = '$dir/';
  final myDir = new Directory(pdfDirectory);
  _folders = myDir.listSync(recursive: true, followLinks: false);
  return _folders;
}

extractHashtags(String data) {
  var re = RegExp(r'"([^]*?)"');
  List<String?> result = re.allMatches(data.trim()).map((data) => data.group(0)).toList();
  return result;
}
initAutoLocalize({required String projectPathApsolute,
  required List<String> locals,
  required String baseLocal})    async {
  projectApsolutePath = projectPathApsolute;
  defaultLocal = baseLocal;
  await Future.wait(locals.map((e) async {
    await  readContent(e);
  }));
}

